/*
  Auto generated by version 0.0 of material_constant_generator.py
  on eduroam-nw-dock-1-133.ethz.ch, at 2015-09-21 13:23:20.589421 by gduclaux
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <petsc.h>

#include "material_constants/EnergySourceConst_def.h"


PetscErrorCode MaterialConstantsReportParseError(const char model_name[],const char field_name[],const int region);

const char EnergySourceConst_classname[] = "EnergySourceConst";

const int EnergySourceConst_nmembers = 1;

const size_t EnergySourceConst_member_sizes[] = {
  1 * sizeof(double)
};

const char *EnergySourceConst_member_names[] = {
  "HeatSource"
};


/* ================================================================= */
/*   Getters for EnergySourceConst */
/* ================================================================= */
void EnergySourceConstGetField_HeatSource(EnergySourceConst *point,double *data)
{
  *data = point->H;
}


/* ================================================================= */
/*   Setters for EnergySourceConst */
/* ================================================================= */
void EnergySourceConstSetField_HeatSource(EnergySourceConst *point,double data)
{
  point->H = data;
}


/* ================================================================= */
/*   C-viewer for EnergySourceConst */
/* ================================================================= */
void EnergySourceConstView(EnergySourceConst *point)
{
  {
    double data;
    EnergySourceConstGetField_HeatSource(point,&data);
    printf("field: HeatSource = %1.6e; [size %zu; type double; variable_name H]\n",data, EnergySourceConst_member_sizes[0] );
  }
}


/* ================================================================= */
/*   Getters for default parameters (EnergySourceConst) */
/* ================================================================= */
void EnergySourceConstGetDefault_HeatSource(double *data)
{
  *data = (double)0.0;
}

void MaterialConstantsSetDefaultAll_SourceConst(
    int nr,EnergySourceConst _data[])
{
  int r;

  for (r=0; r<nr; r++) {
    { double value;
      EnergySourceConstGetDefault_HeatSource((double*)&value);
      EnergySourceConstSetField_HeatSource(&_data[r],(double)value);
    }

  }

}

PetscErrorCode MaterialConstantsSetFromOptions_SourceConst(const char model_name[],const int region_id,EnergySourceConst _data[],PetscBool essential)
{
  char                         opt_name[PETSC_MAX_PATH_LEN];
  PetscBool                    found;
  PetscErrorCode               ierr;

  EnergySourceConst *data = &_data[region_id];
  /* options for HeatSource ==>> H */
  sprintf(opt_name,"-HeatSource_%d",region_id);
  { PetscReal value;
    ierr = PetscOptionsGetReal(NULL,model_name,opt_name,&value,&found);CHKERRQ(ierr);
    if (found) { EnergySourceConstSetField_HeatSource(data,(double)value); }
    else if ( (!found)  && (essential) ) {
      ierr = MaterialConstantsReportParseError(model_name,"HeatSource",region_id);CHKERRQ(ierr);
  }}

  PetscFunctionReturn(0);
}

PetscErrorCode MaterialConstantsPrintValues_SourceConst(const char model_name[],const int region_id,EnergySourceConst _data[])
{
  EnergySourceConst *data = &_data[region_id];
  char   opt_name[PETSC_MAX_PATH_LEN];

  PetscPrintf(PETSC_COMM_WORLD,"------------------------------------------------------------------------------------------------\n");
  PetscPrintf(PETSC_COMM_WORLD,"  MaterialView(SourceConst): RegionIndex[%d]\n", region_id);
  /* options for HeatSource ==>> H */
  sprintf(opt_name,"-%s_HeatSource_%d", model_name,region_id);
  { double value;
    EnergySourceConstGetField_HeatSource(data,(double*)&value);
    PetscPrintf(PETSC_COMM_WORLD,"    HeatSource = %1.4e (%s) \n", value,opt_name);
  }

  PetscFunctionReturn(0);
}

PetscErrorCode MaterialConstantsSetValues_SourceConst(const int region_id,EnergySourceConst _data[],
    double H)
{
  EnergySourceConst *data = &_data[region_id];
  data->H =  H;
  PetscFunctionReturn(0);
}

PetscErrorCode MaterialConstantsScaleValues_SourceConst(const int region_id,EnergySourceConst _data[],
    double H)
{
  EnergySourceConst *data = &_data[region_id];

  { double value;
    EnergySourceConstGetField_HeatSource(data,(double*)&value);
    value = value / H;
    EnergySourceConstSetField_HeatSource(data,(double)value);
  }

  PetscFunctionReturn(0);
}

